#include <iostream>
using namespace std;

const int Maksimalno = 300000;
long long dan_kupovine[Maksimalno];
long long koliko_kutija[Maksimalno];

int main() {


    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int Kada_je_kupio, od_kad_jede;
    cin >> Kada_je_kupio >> od_kad_jede;

    for (int i = 0; i < Kada_je_kupio; i++) {


        cin >> dan_kupovine[i] >> koliko_kutija[i];



    }

    long long ukupno_pojela;

    int pokazivac = 0;

    for (int i = 0; i < od_kad_jede; i++) {


        long long koji_Dan;
        cin >> koji_Dan;

        while (pokazivac < Kada_je_kupio && dan_kupovine[pokazivac] <= koji_Dan) {

            ukupno_pojela += koliko_kutija[pokazivac];
            pokazivac++;

        }


        long long koliko_koliko_je_pojedno = min(ukupno_pojela, koji_Dan);

        cout << pokazivac << endl;



    }








    return 0;
}